#include "stdafx.h"
#include "resource.h"

static HINSTANCE hInst;
static LRESULT CALLBACK DlgProc_winxplayer( HWND hDlg, UINT message, WPARAM wParam, LPARAM lParam );
static char *fname, *value;

static char *szTitle = "݊[h̐ݒ";

static char *sfname, *s_unknown;
static bool bWin95, bWin98SE, bWinNT4SP5, bWin2k, bWinXPSP2, bWinSrv2003SP1,
            bWinXPSP3, bWinVista, bWinVistaSP1, bWinVistaSP2, bWinSrv2008SP1, bWin7RTM, bWin8RTM,
            bw256, bw16bit, bw640, bwnoime, bwnotheme,
            bHiDpiAware, bDisableDwm, bDisableNX, bEnableNX, bRunAsAdmin, bPlaceHolderFiles;

static WORD winver;

BOOL APIENTRY DllMain( HINSTANCE hInstance, DWORD what, LPVOID )
{
	switch (what) {
		case DLL_PROCESS_ATTACH:
            hInst = hInstance;
			break;

		case DLL_PROCESS_DETACH:
			safefree(sfname);
			safefree(s_unknown);
			break;
	}
    return TRUE;
}

static int args_typecheck( struct ARGS *args, char *types ) // ̃`FbN
{
	struct ARGS *p;

	p = args;

	if (p == NULL) {
		if (types == NULL || types[0] == 0)
			return 1; // OK
		else
			return 0; // NG
	}

	do {
		switch ( p->type ) {
			case UFCT_ARG_INT:
				if (*types != 'i')
					return 0; // NG
				break;

			case UFCT_ARG_STRING:
				if (*types != 's')
					return 0; // NG
				break;

			case UFCT_ARG_INTS:
				if (*types != 'a')
					return 0; // NG
				break;

			case UFCT_ARG_STRINGS:
				if (*types != 'r')
					return 0; // NG
				break;
		}
		
		types++;
	} while( (p = p->next) != NULL );

	if ( *types == 0 ) // argsI[ɒBƂAtypeI[ɒB?
		return 1; // OK
	else
		return 0; // NG
}

DllExport UINT editdialog( HWND hWnd, struct ARGS *args )
{
	if ( args_typecheck( args, "ss" ) ) {
		fname = ARG1.text;
		value = ARG2.text;
		return (UINT)DialogBox(hInst, (LPCTSTR)IDD_DIALOG1, hWnd, (DLGPROC)DlgProc_winxplayer);
	}

	return 0;
}

DllExport HGLOBAL getfilename( HWND, struct ARGS *args )
{
	HGLOBAL hMem = 0;
	char *buf;

	if ( sfname && args_typecheck( args, "" ) ) {
		if ( NULL != (hMem = GlobalAlloc( GMEM_MOVEABLE, lstrlen(sfname)+1 )) ) {
			if ( NULL != (buf = (char *)GlobalLock( hMem ) ) ) {
				lstrcpy(buf, sfname);
				GlobalUnlock( hMem );
			}
		}
	}

	return hMem;
}


DllExport HGLOBAL getvalues( HWND, struct ARGS *args )
{
	HGLOBAL hMem = 0;
	char *buf;

	if ( s_unknown && args_typecheck( args, "" ) ) {
		char *valueb = zalloc(lstrlen(s_unknown)+100);

		if (valueb) {
			if ( bWin95 )
				lstrcat( valueb, "WIN95 " );
			else if ( bWin98SE )
				lstrcat( valueb, "WIN98 " );
			else if ( bWinNT4SP5 )
				lstrcat( valueb, "NT4SP5 " );
			else if ( bWin2k )
				lstrcat( valueb, "WIN2000 " );
			else if ( bWinXPSP2 )
				lstrcat( valueb, "WINXPSP2 " );
			else if ( bWinSrv2003SP1 )
				lstrcat( valueb, "WINSRV03SP1 " );
			else if ( bWinXPSP3 )
				lstrcat( valueb, "WINXPSP3 " );
			else if ( bWinVista )
				lstrcat( valueb, "VISTARTM " );
			else if ( bWinVistaSP1 )
				lstrcat( valueb, "VISTASP1 " );
			else if ( bWinVistaSP2 )
				lstrcat( valueb, "VISTASP2 " );
			else if ( bWinSrv2008SP1 )
				lstrcat( valueb, "WINSRV08SP1 " );
			else if ( bWin7RTM )
				lstrcat( valueb, "WIN7RTM " );
			else if ( bWin8RTM )
				lstrcat( valueb, "WIN8RTM " );

			if ( bw256 )
				lstrcat( valueb, "256COLOR " );
			if ( bw16bit )
				lstrcat( valueb, "16BITCOLOR " );
			if ( bw640 )
				lstrcat( valueb, "640X480 " );
			if ( bwnotheme )
				lstrcat( valueb, "DISABLETHEMES " );
			if ( bwnoime )
				lstrcat( valueb, "DISABLECICERO " );
			if ( bHiDpiAware )
				lstrcat( valueb, "HIGHDPIAWARE " );
			if ( bDisableDwm )
				lstrcat( valueb, "DISABLEDWM " );
			if ( bDisableNX )
				lstrcat( valueb, "DisableNXShowUI " );
			if ( bEnableNX )
				lstrcat( valueb, "EnableNXShowUI " );
			if ( bRunAsAdmin )
				lstrcat( valueb, "RUNASADMIN " );
			if ( bPlaceHolderFiles )
				lstrcat( valueb, "PLACEHOLDERFILES " );

			// s̕t
			lstrcat(valueb, s_unknown);

			if ( NULL != (hMem = GlobalAlloc( GMEM_MOVEABLE, lstrlen(valueb)+1 )) ) {
				if ( NULL != (buf = (char *)GlobalLock( hMem ) ) ) {
					lstrcpy(buf, valueb);
					GlobalUnlock( hMem );
				}
			}

			free(valueb);
		}
	}

	return hMem;
}

// EBhEp_CAOvV[W
static LRESULT CALLBACK DlgProc_winxplayer( HWND hDlg, UINT message, WPARAM wParam, LPARAM )
{
	switch( message ) {
		case WM_INITDIALOG:
			if ( fname ) {
				SetDlgItemText(hDlg, IDC_EDIT_FILENAME, fname);
			}

			if ( GetWindowTextLength(GetDlgItem(hDlg, IDC_EDIT_FILENAME)) <= 0 ) {
				EnableWindow(GetDlgItem(hDlg, IDOK), FALSE);
			}

			{
				winver = tf_getWinVer();

				// R{{bNX̏iOo[Wʁj
				// [0]gpȂ
				SendDlgItemMessage(hDlg, IDC_COMBO_OSVER, CB_ADDSTRING, 0, (LPARAM)"gpȂ");
				// [1]Windows 95
				SendDlgItemMessage(hDlg, IDC_COMBO_OSVER, CB_ADDSTRING, 0, (LPARAM)"Windows 95݊(ӎFwvQ)");
				// [2]Windows 98/Me
				SendDlgItemMessage(hDlg, IDC_COMBO_OSVER, CB_ADDSTRING, 0, (LPARAM)"Windows 98 Second Edition݊");
				// [3]Windows NT 4.0 SP5
				SendDlgItemMessage(hDlg, IDC_COMBO_OSVER, CB_ADDSTRING, 0, (LPARAM)"Windows NT 4.0 SP5݊");
				// ftHg̑I=0
				SendDlgItemMessage(hDlg, IDC_COMBO_OSVER, CB_SETCURSEL, 0, 0);
#if _MSC_VER < 1500
#ifndef _WIN64
				if (winver <= 500) { // Windows 2000ȉ
					EnableWindow(GetDlgItem(hDlg, IDC_CHECK_DisableNXShowUI), FALSE);
					EnableWindow(GetDlgItem(hDlg, IDC_CHECK_EnableNXShowUI), FALSE);
				}
#endif /* _WIN64 */
#endif // _MSC_VER < 1500
				if (500 < winver) { // Windows XPȏ
					// [4]Windows 2000
					SendDlgItemMessage(hDlg, IDC_COMBO_OSVER, CB_ADDSTRING, 0, (LPARAM)"Windows 2000݊");

					if (502 < winver) { // Windows Server 2003
						// [5]Windows XP SP2
						SendDlgItemMessage(hDlg, IDC_COMBO_OSVER, CB_ADDSTRING, 0, (LPARAM)"Windows XP SP2݊");
						// [6]Windows Server 2003 SP1
						SendDlgItemMessage(hDlg, IDC_COMBO_OSVER, CB_ADDSTRING, 0, (LPARAM)"Windows Server 2003 SP1݊");

						if (600 < winver) { // Windows 7ȏ
							// [7]Windows XP SP3
							SendDlgItemMessage(hDlg, IDC_COMBO_OSVER, CB_ADDSTRING, 0, (LPARAM)"Windows XP SP3݊");
							// [8]Windows Vista
							SendDlgItemMessage(hDlg, IDC_COMBO_OSVER, CB_ADDSTRING, 0, (LPARAM)"Windows Vista݊");
							// [9]Windows Vista SP1
							SendDlgItemMessage(hDlg, IDC_COMBO_OSVER, CB_ADDSTRING, 0, (LPARAM)"Windows Vista SP1݊");
							// [10]Windows Vista SP2
							SendDlgItemMessage(hDlg, IDC_COMBO_OSVER, CB_ADDSTRING, 0, (LPARAM)"Windows Vista SP2݊");
							// [11]Windows Server 2008 SP1
							SendDlgItemMessage(hDlg, IDC_COMBO_OSVER, CB_ADDSTRING, 0, (LPARAM)"Windows Server 2008 SP1݊");

							if (601 < winver) { // Windows 8ȏ
								// [12]Windows 7
								SendDlgItemMessage(hDlg, IDC_COMBO_OSVER, CB_ADDSTRING, 0, (LPARAM)"Windows 7݊");
							}
							if (602 < winver) { // Windows 8.1ȏ
								// [13]Windows 8
								SendDlgItemMessage(hDlg, IDC_COMBO_OSVER, CB_ADDSTRING, 0, (LPARAM)"Windows 8݊");
							}
						}
					}
				}
				if (winver <= 502) { // Windows Server 2003ȉ
					EnableWindow(GetDlgItem(hDlg, IDC_CHECK_HIGHDPIAWARE), FALSE);	// DPIݒł͉ʂ̃XP[O𖳌ɂ
					EnableWindow(GetDlgItem(hDlg, IDC_CHECK_DISABLEDWM), FALSE);	// fXNgbvR|WViŉʍ\ɏój
					EnableWindow(GetDlgItem(hDlg, IDC_CHECK_RUNASADMIN), FALSE);	// Ǘ҂ƂĎs
				}
				if (winver < 602) { // Win8
					EnableWindow(GetDlgItem(hDlg, IDC_CHECK_16BITCOLOR), FALSE);	// 16rbgi65536jJ[
					EnableWindow(GetDlgItem(hDlg, IDC_CHECK_PLACEHOLDERFILES), FALSE);	// ̃vOOneDrivet@C𑀍ł悤ɂ(Enable this program to work with OneDrive files)
				}
				if (winver >= 602) { // Win8ȏ
					EnableWindow(GetDlgItem(hDlg, IDC_CHECK_NOTHEME), FALSE);		// oe[}
					EnableWindow(GetDlgItem(hDlg, IDC_CHECK_DISABLEDWM), FALSE);	// fXNgbvR|WViŉʍ\ɏój
				}

				// value ̓éBsȃm͕̂܂܎c
				char *pbuf = _strdup(value);
				if ( pbuf == NULL ) {
					MessageBox(hDlg, "Ȃ߁A݊[h̉͂̕ł܂B", szTitle, MB_OK | MB_ICONSTOP);
					EndDialog(hDlg, FALSE);
					return TRUE;
				}

				char *pszUnknown = zalloc(lstrlen(pbuf)+1); // sȕ𗭂ߍł߂̗̈
				if ( pszUnknown == NULL ) {
					MessageBox(hDlg, "Ȃ߁As̉͂ł܂B", szTitle, MB_OK | MB_ICONSTOP);
					EndDialog(hDlg, FALSE);
					return TRUE;
				}

				// Xy[Xf~^Ƃg[N̗
				char *context = NULL, *p;
				p = strtok_s(pbuf, " ", &context);
				while(p) {
					if ( lstrcmpi(p, "WIN95") == 0 )
						SendDlgItemMessage(hDlg, IDC_COMBO_OSVER, CB_SETCURSEL, 1, 0);
					else if ( lstrcmpi(p, "WIN98") == 0 )
						SendDlgItemMessage(hDlg, IDC_COMBO_OSVER, CB_SETCURSEL, 2, 0);
					else if ( lstrcmpi(p, "NT4SP5") == 0 )
						SendDlgItemMessage(hDlg, IDC_COMBO_OSVER, CB_SETCURSEL, 3, 0);
					else if ( lstrcmpi(p, "WIN2000") == 0 )
						SendDlgItemMessage(hDlg, IDC_COMBO_OSVER, CB_SETCURSEL, 4, 0); // Windows XPȍ~
					else if ( lstrcmpi(p, "WINXPSP2") == 0 )
						SendDlgItemMessage(hDlg, IDC_COMBO_OSVER, CB_SETCURSEL, 5, 0); // Windows Vistaȍ~
					else if ( lstrcmpi(p, "WINSRV03SP1") == 0 )
						SendDlgItemMessage(hDlg, IDC_COMBO_OSVER, CB_SETCURSEL, 6, 0); // Windows Vistaȍ~
					else if ( lstrcmpi(p, "WINXPSP3") == 0 )
						SendDlgItemMessage(hDlg, IDC_COMBO_OSVER, CB_SETCURSEL, 7, 0); // Windows 7ȍ~
					else if ( lstrcmpi(p, "VISTARTM") == 0 )
						SendDlgItemMessage(hDlg, IDC_COMBO_OSVER, CB_SETCURSEL, 8, 0); // Windows 7ȍ~
					else if ( lstrcmpi(p, "VISTASP1") == 0 )
						SendDlgItemMessage(hDlg, IDC_COMBO_OSVER, CB_SETCURSEL, 9, 0); // Windows 7ȍ~
					else if ( lstrcmpi(p, "VISTASP2") == 0 )
						SendDlgItemMessage(hDlg, IDC_COMBO_OSVER, CB_SETCURSEL, 10, 0); // Windows 7ȍ~
					else if ( lstrcmpi(p, "WINSRV08SP1") == 0 )
						SendDlgItemMessage(hDlg, IDC_COMBO_OSVER, CB_SETCURSEL, 11, 0); // Windows 7ȍ~
					else if ( lstrcmpi(p, "WIN7RTM") == 0 )
						SendDlgItemMessage(hDlg, IDC_COMBO_OSVER, CB_SETCURSEL, 12, 0); // Windows 8ȍ~
					else if ( lstrcmpi(p, "WIN8RTM") == 0 )
						SendDlgItemMessage(hDlg, IDC_COMBO_OSVER, CB_SETCURSEL, 13, 0); // Windows 8.1ȍ~
					else if ( lstrcmpi(p, "256COLOR") == 0 )
						SendDlgItemMessage( hDlg, IDC_CHECK_256COLOR, BM_SETCHECK, BST_CHECKED, NULL );
					else if ( lstrcmpi(p, "16BITCOLOR") == 0 )
						SendDlgItemMessage( hDlg, IDC_CHECK_16BITCOLOR, BM_SETCHECK, BST_CHECKED, NULL );
					else if ( lstrcmpi(p, "640X480") == 0 )
						SendDlgItemMessage( hDlg, IDC_CHECK_640X480, BM_SETCHECK, BST_CHECKED, NULL );
					else if ( lstrcmpi(p, "DISABLETHEMES") == 0 )
						SendDlgItemMessage( hDlg, IDC_CHECK_NOTHEME, BM_SETCHECK, BST_CHECKED, NULL );
					else if ( lstrcmpi(p, "DISABLECICERO") == 0 )
						SendDlgItemMessage( hDlg, IDC_CHECK_NOIME, BM_SETCHECK, BST_CHECKED, NULL );
					else if ( lstrcmpi(p, "HIGHDPIAWARE") == 0 )
						SendDlgItemMessage( hDlg, IDC_CHECK_HIGHDPIAWARE, BM_SETCHECK, BST_CHECKED, NULL );
					else if ( lstrcmpi(p, "DISABLEDWM") == 0 )
						SendDlgItemMessage( hDlg, IDC_CHECK_DISABLEDWM, BM_SETCHECK, BST_CHECKED, NULL );
					else if ( lstrcmpi(p, "DisableNXShowUI") == 0 )
						SendDlgItemMessage( hDlg, IDC_CHECK_DisableNXShowUI, BM_SETCHECK, BST_CHECKED, NULL );
					else if ( lstrcmpi(p, "EnableNXShowUI") == 0 )
						SendDlgItemMessage( hDlg, IDC_CHECK_EnableNXShowUI, BM_SETCHECK, BST_CHECKED, NULL );
					else if ( lstrcmpi(p, "RUNASADMIN") == 0 )
						SendDlgItemMessage( hDlg, IDC_CHECK_RUNASADMIN, BM_SETCHECK, BST_CHECKED, NULL );
					else if ( lstrcmpi(p, "PLACEHOLDERFILES") == 0 )
						SendDlgItemMessage( hDlg, IDC_CHECK_PLACEHOLDERFILES, BM_SETCHECK, BST_CHECKED, NULL );
					else {
						// sȌ݊͒~
						lstrcat(pszUnknown, p);
						lstrcat(pszUnknown, " ");
					}

					// ̃g[N{
					p = strtok_s(NULL, " ", &context);
				}

				// sȌ݊܂Ƃ߂
				SetDlgItemText(hDlg, IDC_EDIT_UNKNOWN, pszUnknown);

				free(pszUnknown);
				free(pbuf);
			}
			return TRUE;

		case WM_COMMAND:
			switch ( LOWORD(wParam) ) {
				case IDOK:
					if ( GetWindowTextLength(GetDlgItem(hDlg, IDC_EDIT_FILENAME)) <= 0 ) {
						MessageBox(hDlg, "t@C͂ĉB", "݊[hݒ", MB_OK | MB_ICONSTOP);
					}
					else {
						int iCur = (int)SendDlgItemMessage(hDlg, IDC_COMBO_OSVER, CB_GETCURSEL, 0, 0);

						bWin95 = bWin98SE = bWinNT4SP5 = bWin2k = bWinXPSP2 = bWinSrv2003SP1 =
						         bWinXPSP3 = bWinVista = bWinVistaSP1 = bWinVistaSP2 = bWinSrv2008SP1 =
								 bWin7RTM = bWin8RTM = 0;

						switch(iCur) {
							case 1:
								bWin95 = 1;
								break;
							case 2:
								bWin98SE = 1;
								break;
							case 3:
								bWinNT4SP5 = 1;
								break;
							case 4:
								bWin2k = 1;
								break;
							case 5:
								bWinXPSP2 = 1;
								break;
							case 6:
								bWinSrv2003SP1 = 1;
								break;
							case 7:
								bWinXPSP3 = 1;
								break;
							case 8:
								bWinVista = 1;
								break;
							case 9:
								bWinVistaSP1 = 1;
								break;
							case 10:
								bWinVistaSP2 = 1;
								break;
							case 11:
								bWinSrv2008SP1 = 1;
								break;
							case 12:
								bWin7RTM = 1;
								break;
							case 13:
								bWin8RTM = 1;
								break;
						}

						bw256       = (SendDlgItemMessage( hDlg, IDC_CHECK_256COLOR, BM_GETCHECK, 0, NULL ) == BST_CHECKED);
						bw16bit     = (SendDlgItemMessage( hDlg, IDC_CHECK_16BITCOLOR, BM_GETCHECK, 0, NULL ) == BST_CHECKED);
						bw640       = (SendDlgItemMessage( hDlg, IDC_CHECK_640X480, BM_GETCHECK, 0, NULL ) == BST_CHECKED);
						bwnotheme   = (SendDlgItemMessage( hDlg, IDC_CHECK_NOTHEME, BM_GETCHECK, 0, NULL ) == BST_CHECKED);
						bwnoime     = (SendDlgItemMessage( hDlg, IDC_CHECK_NOIME, BM_GETCHECK, 0, NULL ) == BST_CHECKED);
						bHiDpiAware = (SendDlgItemMessage( hDlg, IDC_CHECK_HIGHDPIAWARE, BM_GETCHECK, 0, NULL ) == BST_CHECKED);
						bDisableDwm = (SendDlgItemMessage( hDlg, IDC_CHECK_DISABLEDWM, BM_GETCHECK, 0, NULL ) == BST_CHECKED);
						bDisableNX  = (SendDlgItemMessage( hDlg, IDC_CHECK_DisableNXShowUI, BM_GETCHECK, 0, NULL ) == BST_CHECKED); 
						bEnableNX   = (SendDlgItemMessage( hDlg, IDC_CHECK_EnableNXShowUI, BM_GETCHECK, 0, NULL ) == BST_CHECKED);
						bRunAsAdmin = (SendDlgItemMessage( hDlg, IDC_CHECK_RUNASADMIN, BM_GETCHECK, 0, NULL ) == BST_CHECKED);
						bPlaceHolderFiles = (SendDlgItemMessage( hDlg, IDC_CHECK_PLACEHOLDERFILES, BM_GETCHECK, 0, NULL ) == BST_CHECKED);

						// t@CtpX̕ҏW{bNX̓̕ǂݎ
						safefree(sfname);
						int len = GetWindowTextLength( GetDlgItem(hDlg, IDC_EDIT_FILENAME) )+1;
						sfname = zalloc(len);
						if ( sfname ) {
							GetDlgItemText(hDlg, IDC_EDIT_FILENAME, sfname, len);
						}
						else {
							MessageBox(hDlg, "ŝ߁At@Ci[ł܂B", szTitle, MB_OK | MB_ICONSTOP);
						}

						// ŝ܂Ƃ
						safefree(s_unknown);
						len = GetWindowTextLength( GetDlgItem(hDlg, IDC_EDIT_UNKNOWN) )+1;
						s_unknown = zalloc(len);
						if ( s_unknown ) {
							GetDlgItemText(hDlg, IDC_EDIT_UNKNOWN, s_unknown, len);
						}
						else {
							MessageBox(hDlg, "ŝ߁Ȃ̎擾ł܂B", szTitle, MB_OK | MB_ICONSTOP);
						}

						EndDialog(hDlg, TRUE);
					}
					return TRUE;

				case IDCANCEL:
					EndDialog(hDlg, FALSE);
					return TRUE;

				case IDC_BUTTON_BROWSE:
					{
						OPENFILENAME ofn;
						char fname[MAX_PATH*2]="";

						GetDlgItemText(hDlg, IDC_EDIT_FILENAME, fname, _countof(fname));

						ofn.lStructSize = sizeof(OPENFILENAME);
						ofn.hwndOwner = hDlg;
						ofn.lpstrFilter = "st@C(*.exe)\0*.exe\0ׂẴt@C(*.*)\0*.*\0\0";
						ofn.nFilterIndex = 1;
						ofn.lpstrCustomFilter = (LPSTR) NULL;
						ofn.nMaxCustFilter = 0L;
						ofn.lpstrFile = fname;
						ofn.nMaxFile = _countof(fname);
						ofn.lpstrFileTitle = NULL;
						ofn.nMaxFileTitle = 0;
						ofn.lpstrInitialDir = NULL;
						ofn.lpstrTitle = "st@Cw";
						ofn.Flags = OFN_PATHMUSTEXIST | OFN_FILEMUSTEXIST | OFN_HIDEREADONLY | OFN_NOCHANGEDIR;
						ofn.nFileOffset = 0;
						ofn.nFileExtension = 0;
						ofn.lpstrDefExt = "exe"; 

						if (GetOpenFileName(&ofn)) {
							SetDlgItemText(hDlg, IDC_EDIT_FILENAME, fname);
						}
					}			
					SetFocus(GetDlgItem(hDlg,IDC_EDIT_FILENAME));
					EnableWindow(GetDlgItem(hDlg, IDOK), GetWindowTextLength(GetDlgItem(hDlg, IDC_EDIT_FILENAME)) > 0? TRUE : FALSE);
					return TRUE;

				case IDC_EDIT_FILENAME:
					if ( HIWORD(wParam) == EN_CHANGE ) {
						EnableWindow(GetDlgItem(hDlg, IDOK), GetWindowTextLength(GetDlgItem(hDlg, IDC_EDIT_FILENAME)) > 0? TRUE : FALSE  );
					}
					return TRUE;

				case IDC_COMBO_OSVER:
					if ( HIWORD(wParam) != CBN_SELCHANGE ) {
						return TRUE;
					}
				case IDC_CHECK_256COLOR:
				case IDC_CHECK_16BITCOLOR:
				case IDC_CHECK_640X480:
				case IDC_CHECK_NOIME:
				case IDC_CHECK_NOTHEME:
				case IDC_CHECK_HIGHDPIAWARE:
				case IDC_CHECK_DISABLEDWM:
				case IDC_CHECK_DisableNXShowUI:
				case IDC_CHECK_EnableNXShowUI:
				case IDC_CHECK_RUNASADMIN:
				case IDC_CHECK_PLACEHOLDERFILES:
					EnableWindow(GetDlgItem(hDlg, IDOK), TRUE);
					return TRUE;
			}
			break;
	}
    return FALSE;
}
